unit aulavirtual;

{$mode objfpc}{$H+}

interface

uses
  IniFiles,globales,Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Buttons;

type

  { TfrmVirtual }

  TfrmVirtual = class(TForm)
    btnLimpiar: TButton;
    btnEliminar: TButton;
    btnModificar: TButton;
    btnAnadir: TButton;
    bitConectar: TButton;
    btnSalir: TButton;
    cboNumCol: TComboBox;
    cboNumOrd: TComboBox;
    cboIpMacs: TComboBox;
    edAula: TEdit;
    imlOrd: TImageList;
    lblmen: TLabel;
    lstAulas: TListBox;
    procedure bitConectarClick(Sender: TObject);
    procedure btnAnadirClick(Sender: TObject);
    procedure btnEliminarClick(Sender: TObject);
    procedure btnLimpiarClick(Sender: TObject);
    procedure btnModificarClick(Sender: TObject);
    procedure btnSalirClick(Sender: TObject);
    procedure cboIpMacsChange(Sender: TObject);
    procedure cboIpMacsClick(Sender: TObject);
    procedure cboNumColChange(Sender: TObject);
    procedure cboNumColClick(Sender: TObject);
    procedure cboNumColKeyPress(Sender: TObject; var Key: char);
    procedure cboNumOrdChange(Sender: TObject);
    procedure cboNumOrdKeyPress(Sender: TObject; var Key: char);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure lstAulasClick(Sender: TObject);
  private
    procedure AnadirAulaVirtual();
    procedure CrearEtiquetasOr();
    procedure CrearOrdenadores();
    procedure CrearTarea(aula: string);
    procedure edMACKeyPress(Sender: TObject; var Key: Char);
    procedure edOrdKeyPress(Sender: TObject; var Key: Char);
    procedure EliminarAula(aulaeliminada: integer);
    procedure EscribirDatosAulas();
    procedure HallarEquiposDnsMasq();
    procedure LeerDatosAulas();
    procedure LimpiarCampos();
    procedure LimpiarCampos1();
    procedure MACmanual();
    procedure ModificarAulas();
    procedure MostrarAula();
    procedure MostrarOrdenadores(numaula, numpan: integer);
    function NumOrdPantalla(Or_Au: integer): integer;
    procedure OcultarOrdenatas;
    procedure OrdenadoresCombo(no: integer; cboC: TCombobox);
    function ValidarDatos(): boolean;
    { private declarations }
  public
    { public declarations }
  end; 
type aulav=record
     nombre:string;
     numord:integer;
     numfilas:integer;
     ips:array [0..50] of string;
     macs:array [0..50]of string;
     alumnos:array [0..50]of string;
     //estado:array [0..50]of integer;
 end;

var
  frmVirtual: TfrmVirtual;
  misaulas:array [0..50] of aulav;
  OrdCon:array[0..23] of Tbitbtn;
  edOrd:array[0..23] of TEdit;
  edMAC:array[0..23] of TEdit;
  edNombres:array[0..23] of TEdit;


implementation
uses inicio;
const
    MEN_SALIR_ADMIN:string='¿Deseas salir de esta zona?';
    MEN_ELIGE_NUM_ORD:string='selecciona el número de ordenadores de aula';
    MEN_ORDENADORES_ENCENDIDOS:string='No se ha podido descargar una copia del dnsamasq.leases. Se intentará la obtención directa de las MACs. Debe encender todos los equipos del aula virtual. ¿Desea continuar?';
    MEN_NUMERO_FILAS:string='Selecciona el número de filas del aula';
    MEN_NUMERO_ORDENADORES:string='Elige el número de ordenadores';
    MEN_GUARDAR_CAMBIOS:string='¿Desea guardar los cambios realizados?';
    MEN_IPS_ALUMNOS:string='Tienes que indicar un nombre o IP para todos los ordenadores';
    MEN_INDICA_AULA:string='Escribe un nombre para el aula';
var
f_numaulas:integer=0;
f_aulaactiva:integer=-1;
f_NumeroOrdernadores:integer;
procedure TfrmVirtual.HallarEquiposDnsMasq();
    const
        BUSCAR_MAC:STRING='grep -i %s  /tmp/ndns.txt | cut -f2 -d" "';
    var
        numor,i:integer;
        ordenmac:string;
    begin
        (*Comprobamos si hemos descargado el archivo dnsmasq en
           la carpeta /tmp. Si es así hallamos las MACs de los equipos
           utilizando grep, si no se ha descargado lo intentamos
           directamente *)
        if not FileExists('/tmp/ndns.txt') then
            MACmanual()
        else
            begin
            numor:=strtoint(cboNumOrd.Text);
            for i:=0 to numor-1 do
                begin
                    ordenmac:=format(BUSCAR_MAC,[edord[i].text]);
                    edMac[i].Text:=HallarDato(ordenmac);
                    application.ProcessMessages;
                    if edMac[i].text='' then
                        Mensaje('No se ha podido obtener la MAC del equipo '+ edord[i].text
                                + '. Revise el nombre y si es correcto consulte a su administrador',aceptar);

                end;
        end;
          cboIpMacs.ItemIndex:=2;
          cboIpMacsChange(cboipmacs);
    end;
 procedure TfrmVirtual.MACmanual();
    var
        l,i:integer;
        nomorde,ordenmac:string;
    begin
        //Conecta con los ordenadores mediante ping si el ordenador responde
        //le pregunta su mac
        if length(cbonumord.Text)<1 then
            begin
                mensaje(MEN_ELIGE_NUM_ORD,aceptar);
                exit;
            end;
        if mensaje(MEN_ORDENADORES_ENCENDIDOS,sino)=2 then exit;
        enabled:=false;
        try
            for i:=0 to strtoint(cbonumord.Text)-1 do
                begin
                    nomorde:='ping -c 1 '+edOrd[i].text;
                    l:=0;
                    //l:=libc.system(pchar(nomorde));
                    if l=0 then
                        begin
                        //OrdCon[i].Down:=false;
                        ordenmac:=format(g_orden_mac,[edord[i].Text]);
                        edmac[i].Text:=trim(HallarDato(ordenmac));
                        end
                    else
                        //OrdCon[i].Down:=true;
                        application.ProcessMessages;
                end;
        finally
            enabled:=true;
        end;
    end;
 Function TfrmVirtual.ValidarDatos():boolean;
    var
        TextoMensaje:string;
        i:integer;
    begin
        //Comprueba que se hallan completado todos los datos
        TextoMensaje:='';
        if length(edAula.Text)<1 then
            TextoMensaje:=MEN_INDICA_AULA
        else if length(cbonumcol.Text)<1 then
            TextoMensaje:=MEN_NUMERO_FILAS
        else if length(cbonumord.Text) <1 then
            TextoMensaje:=MEN_NUMERO_ORDENADORES
        else if length(cboNumOrd.text)=0 then
            TextoMensaje:='El aula tiene que tener al menos un equipo'

        else
            begin
                for i:=0 to strtoint(cboNumOrd.text)-1 do
                    if length(Trim(edNombres[i].Text))<2 then
                        begin
                            TextoMensaje:='Completa los nombres de los alumnos';
                            cboIpMacs.ItemIndex:=1;
                            cboIpMacsChange(cboIpMacs)
                        end;
                for i:=0 to strtoint(cboNumOrd.text)-1 do
                    if length(Trim(edord[i].text))<2 then
                        begin
                            TextoMensaje:=MEN_IPS_ALUMNOS;
                            cboIpMacs.ItemIndex:=0;
                            cboIpMacsChange(cboIpMacs)
                        end;
            end;
        result:=TextoMensaje='';
        if not result then
                mensaje(TextoMensaje,aceptar);
    end;
procedure TfrmVirtual.CrearOrdenadores();
    var
        i:integer;
    begin
        //Creamos los ordenadores
        for i:= low(ordcon) to high(ordcon) do
            begin
                ordcon[i]:=Tbitbtn.Create(self);
                with ordcon[i] do
                    begin
                        tag:=i;
                        Color:=clwhite;
                        //ToggleButton:=true;
                        Visible:=false;
                        imlord.GetBitmap(0,Glyph);
                        NumGlyphs:=4;
                        Enabled:=true;
                        Cursor:=crarrow;
                        Parent:=self;
                    end;
            end;
    end;
procedure TfrmVirtual.CrearEtiquetasOr();
    var
        i:integer;
    begin
         //Creamos los edits para equipos, MACs y mp,bres
        for i:= low(edOrd) to high(edOrd) do
            begin
                edOrd[i]:=Tedit.Create(self);
                with edOrd[i] do
                    begin
                        tag:=i;
                        Color:=rgb(223,236,251);
                        font.Name:='Helvetica';
                        //Alignment:=taCenter;
                        MaxLength:=15;
                        font.Size:=11;
                        Visible:=false;
                        Enabled:=true;
                        text:='';
                        Cursor:=crdefault;
                        OnKeyPress:=@edOrdKeyPress;
                        Parent:=self;
                    end;
                end;
        for i:= low(edMAC) to high(edMAC) do
            begin
                edMAC[i]:=Tedit.Create(self);
                with edMAC[i] do
                    begin
                        tag:=i;
                        Color:= rgb(255,228,174);
                        font.Name:='Helvetica';
                        //Alignment:=taCenter;
                        font.Size:=11;
                        Visible:=false;
                        Enabled:=true;
                        text:='00:00:00:00:00:00';
                        MaxLength:=17;
                        Cursor:=crdefault;
                        OnKeyPress:=@edMACKeyPress;
                        Parent:=self;
                    end;
               edNombres[i]:=Tedit.Create(self);
                    with edNombres[i] do
                    begin
                        tag:=i;
                        Color:=rgb(204,255,204);
                        font.Name:='Helvetica';
                        MaxLength:=22;
                        //Alignment:=taCenter;
                        font.Size:=11;
                        Visible:=false;
                        Enabled:=true;
                        text:='';
                        Cursor:=crdefault;
                        Parent:=self;
                    end;
            end;
    end;

procedure TfrmVirtual.edMACKeyPress(Sender: TObject; var Key: Char);
    begin
        if not(key in['a'..'f','A'..'F','0'..'9',':',#8]) then
            key:=#0;
    end;

procedure TfrmVirtual.edOrdKeyPress(Sender: TObject; var Key: Char);
    begin
        if not(key in['a'..'z','A'..'Z','0'..'9','.','-','_',#8]) then
            key:=#0;
    end;
procedure TfrmVirtual.OcultarOrdenatas;
    var
        i:integer;
    begin
        //Ocultarmos etiquetas y ordenadores
        for i:=low(ordcon) to high(ordcon) do
            begin
                ordcon[i].visible:=false;
                edord[i].visible:=false;
                edmac[i].visible:=false;
                edNombres[i].Visible:=false;
            end;
    end;

procedure TfrmVirtual.cboIpMacsChange(Sender: TObject);
    var
        i:integer;
    begin
        //Ocultamos todas las etiquetas menos las seleccionadas
        if length(cboNumOrd.Text) = 0 then exit;
            for i:=0 to 23 do
                begin
                    edord[i].visible:=false;
                    edNombres[i].Visible:=false;
                    edMac[i].Visible:=false;
                end;
        case (sender as TComboBox).ItemIndex of
            0:
              begin
                  for i:=0 to (strtoint(cboNumOrd.Text)-1) do
                      edord[i].visible:=true;
                     lblmen.Caption:='Completa los nombres de los equipos: a01-o03, a03-o05..';
              end;
            1:
              begin
                  for i:=0 to (strtoint(cboNumOrd.Text)-1) do
                      edNombres[i].Visible:=true;
                  lblmen.Caption:='Indica los nombres de los alumno: Juan, Luisa-Pedro..';
              end;
            2:
              begin
                  for i:=0 to (strtoint(cboNumOrd.Text)-1) do
                      edmac[i].visible:=true;
                  lblmen.Caption:='Pulsa Hallar Mac. Si no aparece alguna MAC, posiblemente el nombre de equipo elegido no exista, consulta a tu administrador';
              end;
        end;
    end;

procedure TfrmVirtual.cboIpMacsClick(Sender: TObject);
begin
end;

procedure TfrmVirtual.cboNumColChange(Sender: TObject);
    begin
        OrdenadoresCombo(strtoint(cbonumcol.text),cbonumord);
        OcultarOrdenatas();
        cbonumord.Text:='';
    end;

procedure TfrmVirtual.cboNumColClick(Sender: TObject);
begin

end;

procedure TfrmVirtual.cboNumColKeyPress(Sender: TObject; var Key: char);
    begin
        key:=#0
    end;

procedure TfrmVirtual.cboNumOrdChange(Sender: TObject);
    begin
        //Mostramos los iconos de los ordenadores
        f_NumeroOrdernadores:=strtoint(cbonumord.Text);
        MostrarOrdenadores(f_NumeroOrdernadores,NumOrdPantalla(f_NumeroOrdernadores));
        cboIpMacs.Itemindex:=0;
        lblmen.Caption:='Completa los nombres de los equipos: a01-o03, a03-o05..';
    end;

procedure TfrmVirtual.cboNumOrdKeyPress(Sender: TObject; var Key: char);
begin

end;

procedure TfrmVirtual.FormActivate(Sender: TObject);
    begin
       if frmMain.Visible then frmMain.hide;
    end;

procedure TfrmVirtual.FormClose(Sender: TObject; var CloseAction: TCloseAction);
    begin
        //Cerramos los dataset y cargamos las aulas virtuales en el menu
        // del formulario principal
        if mensaje(MEN_GUARDAR_CAMBIOS, sino) =1 then
             EscribirDatosAulas();
        CloseAction:=cafree;
    end;

procedure TfrmVirtual.FormCloseQuery(Sender: TObject; var CanClose: boolean);
    begin
        //Si deseamos salir mostramos el formulario principal
        if mensaje(MEN_SALIR_ADMIN,sino)=2 then
            canclose:=false
        else
            begin
                frmMain.show;
                hide;
            end;
    end;

procedure TfrmVirtual.FormCreate(Sender: TObject);
    Const
        ORDEN_DESCARGAR: string='wget -t3 http://%s/ficheros/2004/dnsmasq.leases -O /tmp/ndns.txt &';
    var
        descargar:string;
        servidor:string;
    begin
        //Situamos el formulario y creamos etiquetas y ordenadores
          top:=13;left:=(screen.Width-width)div 2;
        CrearOrdenadores();
        CrearEtiquetasOr();
        //Descargamos el fichero dnsmasq que utilizaremos para obtener las mac
        servidor:=leftstr(g_servidor,length(g_servidor)-1)+'2';
        if servidor ='192.168.1.2' then servidor :='192.168.1.3';
        descargar:=Format(ORDEN_DESCARGAR,[servidor]);
        Ejecutar(pchar(descargar));
        //Leemos la base de datos .aulalinex/virtuales.myb
        // y cargarmos las clases existentes;
        if fileexists('C:\aulasvirtuales.ini') then
           LeerDatosAulas();
        //CargarLista;
    end;

procedure TfrmVirtual.lstAulasClick(Sender: TObject);
    begin
        MostrarAula;
    end;

procedure TfrmVirtual.bitConectarClick(Sender: TObject);
    begin
        HallarEquiposDnsMasq;
    end;

procedure TfrmVirtual.btnAnadirClick(Sender: TObject);
    begin
        if validardatos() then
                AnadirAulaVirtual();
    end;

procedure TfrmVirtual.btnEliminarClick(Sender: TObject);
    var
        aula:string;
    begin
        // Eliminamos el aula y refrescamos la lista
        if (lstaulas.Items.count=0) or (lstaulas.ItemIndex=-1)  then exit;
        aula:=edAula.text;
        if lstAulas.Items.IndexOf(aula) <>-1 then
            begin
                if mensaje('¿Desea eliminar el aula ' +aula+'?',sino)=2 then exit;
                   EliminarAula(lstAulas.itemindex);
                   lstaulas.Items.Delete(lstAulas.itemindex);
                   btneliminar.Enabled:=false;
                   btnModificar.Enabled:=false;
                   LimpiarCampos;
                   f_aulaactiva:=-1;
                   mensaje('el grupo ha sido eliminado correctamente',aceptar);
            end
    end;

procedure TfrmVirtual.btnLimpiarClick(Sender: TObject);
    begin
        limpiarcampos1();
    end;

procedure TfrmVirtual.btnModificarClick(Sender: TObject);
begin
  ModificarAulas();
end;

procedure TfrmVirtual.btnSalirClick(Sender: TObject);
    begin
        close;
    end;

procedure TfrmVirtual.AnadirAulaVirtual();
    var
        i:integer;
    begin
        //Comprobas que no exista el aula que queremos añadir
        //y completamos los datos
        lstAulas.items.add(trim(edaula.Text));
        f_numaulas:=f_numaulas+1;
        f_aulaactiva:=f_numaulas-1;
        misaulas[f_aulaactiva].nombre:=trim(edaula.Text);
        misaulas[f_aulaactiva].numfilas:=strtoint(cboNumCol.text);
        misaulas[f_aulaactiva].numord:=strtoint(cboNumOrd.text);
        for i:=0 to strtoint(cboNumOrd.text)-1 do
          begin
              misaulas[f_aulaactiva].ips[i]:=edord[i].text;
              misaulas[f_aulaactiva].alumnos[i]:=ednombres[i].text;
              misaulas[f_aulaactiva].macs[i]:=edMac[i].text;

          end;
        CrearTarea(edaula.text);
        LimpiarCampos();
        mensaje('el aula ha sido añadida correctamente',aceptar);
    end;

procedure TfrmVirtual.OrdenadoresCombo(no:integer;cboC:TCombobox);
    var
        i:integer;
    begin
        //Muestra un número de ordenadores diferentes en el combo numero de ordenadores
        cboC.Text:='';
        cboC.Clear;
        if no=2 then
        no:=12
        else
        no:=18;
       // no:=ifthen(no=2,12,18);
        for i:=1 to no do
                cboC.Items.Add(inttostr(i));
        cboc.Enabled:=true;
    end;
Procedure TfrmVirtual.MostrarOrdenadores(numaula,numpan:integer);
    const
        tor:integer=510;
        wo:integer=66;ho:integer=61;
    var
        lor,sepl,lb,tb,spt,i,numsep,numfilas:integer;
        posi3,posi2,cambioi:integer;
        numcol:integer;
    begin
        //Muestra los ordenadores selecionados
        OcultarOrdenatas;
        numcol:=strtoint(cboNumCol.Text);
        if numcol=3 then
            sepl:=150
        else
            sepl:=260;
        application.ProcessMessages;
        if g_TipoClase=1 then
            begin
                cambioi:=1;
                posi3:=480;
                posi2:=500;
            end
        else
            begin
                cambioi:=-1;
                posi3:=783;
                posi2:=763;
            end;
       // lor:=ifthen(numcol=3,posi3,posi2);
        if numcol=3 then
        lor:=posi3
        else
        lor:=posi2;
        numfilas:=(numpan div numcol);
        numsep:=numfilas -1;
        spt:=(510-(numfilas*63)) div numsep;
        for i:=numaula-1 downto 0  do
            begin
                tb:= i div numcol;
                tb:= tor-tb*(63+spt);
                lb:= i mod numcol;
                lb:= lor+ cambioi*lb*sepl;
                with ordcon[i] do
                    begin
                       SetBounds(lb,tb,wo,ho);
                       visible:=true;
                    end;
                 with edord[i]do
                    begin
                        SetBounds(lb-23,tb+64,wo+47,23);
                         visible:=true;
                    end;
                 with edmac[i]do
                    begin
                        SetBounds(lb-23,tb+64,wo+47,23);
                    end;
                 with edNombres[i]do
                    begin
                        SetBounds(lb-23,tb+64,wo+47,23);
                    end;
            end;
    end;
Function TfrmVirtual.NumOrdPantalla(Or_Au:integer):integer;
    begin
        case Or_Au of
            0..12: result:=12;
            13..15:result:=15
        else
            result:=18
        end;
    end;

procedure TfrmVirtual.MostrarAula();
    var
        i:integer;
    begin
        if lstaulas.itemindex=-1 then exit;
        f_aulaactiva:=lstAulas.itemindex;
        edaula.Text:=misaulas[f_aulaactiva].nombre;
        cboNumCol.Text:=inttostr(misaulas[f_aulaactiva].numfilas);
        OrdenadoresCombo(misaulas[f_aulaactiva].numfilas,cbonumord);
        application.ProcessMessages;
        Mostrarordenadores(misaulas[f_aulaactiva].numord,NumOrdPantalla(misaulas[f_aulaactiva].numord));
        btnEliminar.Enabled:=true;
        btnModificar.Enabled:=true;
        cboNumOrd.Text:=inttostr(misaulas[f_aulaactiva].numord);
        for i:=0 to misaulas[f_aulaactiva].numord -1 do
            begin
                edord[i].text:=misaulas[f_aulaactiva].ips[i];
                edNombres[i].Text:= misaulas[f_aulaactiva].alumnos[i];
                edMac[i].Text:=misaulas[f_aulaactiva].macs[i];
            end;

    end;

procedure TfrmVirtual.LeerDatosAulas();
    const
        AULAS_VIRTUALES:string='C:\aulasvirtuales.ini';
    var
        Mifichero:TMemIniFile;
        j,i:integer;
    begin
        f_aulaactiva:=-1;
        f_numaulas:=0;
        //Crea el archivo que contiene el mensaje que se enviará a los alumnos
          lstAulas.clear;
        try
          Mifichero := TMemIniFile.Create(AULAS_VIRTUALES);
            try
                with Mifichero do
                    begin
                        f_numaulas:=ReadInteger('AULAS_VIRTUALES','numero_aulas',0);
                        For j:=0 to -1 do
                            begin
                             misaulas[j].nombre:= ReadString('AULA_'+inttostr(j),'nombre', '');
                             lstAulas.Items.Add(misaulas[j].nombre);
                             misaulas[j].numord:= ReadInteger('AULA_'+inttostr(j),'numero_equipos',0 );
                             misaulas[j].numfilas:= ReadInteger('AULA_'+inttostr(j),'numero_filas',0);
                                for i:=0 to misaulas[j].numord-1 do
                                    begin
                                        misaulas[j].alumnos[i]:=ReadString('AULA_'+inttostr(j),'alumnos_'+inttostr(i),'' );
                                        misaulas[j].ips[i]:=ReadString('AULA_'+inttostr(j),'ip_'+inttostr(i), '');
                                        misaulas[j].macs[i]:=ReadString('AULA_'+inttostr(j),'mac_'+inttostr(i), '');
                                    end
                            end;
                    end;
                sleep(100);
                application.ProcessMessages;
            finally
                Mifichero.free;
            end;
        except
            //Mensaje('Error al crear examen',aceptar);
        end;
 end;

procedure TfrmVirtual.EscribirDatosAulas();
    const
        AULAS_VIRTUALES:string='C:\aulasvirtuales.ini';
    var
        Mifichero:TMemIniFile;
        j,i:integer;
    begin
        f_numaulas:=lstAulas.Count;
        if f_numaulas=0 then exit;
        //Crea el archivo que contiene el mensaje que se enviará a los alumnos
        try

          Mifichero := TMemIniFile.Create(AULAS_VIRTUALES);
            try
                with Mifichero do
                    begin
                        writeInteger('AULAS_VIRTUALES','numero_aulas',f_numaulas);
                        For j:=0 to f_numaulas-1 do
                            begin
                                WriteString('AULA_'+inttostr(j),'nombre', misaulas[j].nombre);
                                WriteInteger('AULA_'+inttostr(j),'numero_equipos', misaulas[j].numord);
                                WriteInteger('AULA_'+inttostr(j),'numero_filas', misaulas[j].numfilas);
                                for i:=0 to misaulas[j].numord-1 do
                                    begin
                                        WriteString('AULA_'+inttostr(j),'alumnos_'+inttostr(i), misaulas[j].alumnos[i]);
                                        WriteString('AULA_'+inttostr(j),'ip_'+inttostr(i), misaulas[j].ips[i]);
                                        WriteString('AULA_'+inttostr(j),'mac_'+inttostr(i), misaulas[j].macs[i]);
                                       // WriteInteger('AULA_'+inttostr(j),'estado_'+inttostr(i), misaulas[j].estado[j][i]);
                                    end
                            end;
                        UpdateFile;
                    end;
                sleep(100);
                application.ProcessMessages;
            finally
                Mifichero.free;
            end;
        except
            //Mensaje('Error al crear examen',aceptar);
        end;
 end;
procedure TfrmVirtual.EliminarAula(aulaeliminada:integer);
    var
    aulax:array [0..50] of aulav;
    i,j,z:integer;
    begin
       j:=0;
       for i:=0 to f_numaulas do
           begin
              if i<>aulaeliminada then
                  begin
                      aulax[j].nombre:=misaulas[i].nombre;
                      aulax[j].numord:=misaulas[i].numord;
                      aulax[j].numfilas:=misaulas[i].numfilas;
                      for z:=0 to misaulas[i].numord -1 do
                          begin
                              aulax[j].alumnos[z]:=misaulas[i].alumnos[z];
                              aulax[j].ips[z]:=misaulas[i].ips[z];
                              aulax[j].macs[z]:=misaulas[i].macs[z];
                          end;
                     inc(j);
                  end;
           end;
       f_numaulas:=f_numaulas-1;
       for i:=0 to f_numaulas do
           begin
              misaulas[i].nombre:=aulax[i].nombre;
              misaulas[i].numord:=aulax[i].numord;
              misaulas[i].numfilas:=aulax[i].numfilas;
              for z:=0 to aulax[i].numord -1  do
                  begin
                      misaulas[i].alumnos[z]:=aulax[i].alumnos[z];
                      misaulas[i].ips[z]:=aulax[i].ips[z];
                      misaulas[i].macs[z]:=aulax[i].macs[z];
                  end;
           end
    end;
procedure TfrmVirtual.ModificarAulas();
    var
        z :integer;
        aulamodificada: integer;
    begin
        aulamodificada:=lstAulas.ItemIndex;
        if aulamodificada= -1 then exit;
        misaulas[aulamodificada].nombre:=trim(edaula.Text);
        misaulas[aulamodificada].numord:=strtoint(cboNumOrd.text);
        misaulas[aulamodificada].numfilas:=strtoint(cboNumCol.text);
        for z:=0 to strtoint(cboNumOrd.text)-1 do
            begin
                misaulas[aulamodificada].alumnos[z]:=ednombres[z].text;
                misaulas[aulamodificada].ips[z]:=edord[z].text;
                misaulas[aulamodificada].macs[z]:=edMac[z].text;
            end;
        mensaje('El aula ha sido modificada correctamente',aceptar)
    end;
procedure TfrmVirtual.CrearTarea(aula:string);
    const
        BUSCAR_IP_PROFE:STRING='grep -i %s  /tmp/ndns.txt | cut -f3 -d" "';
    var
        stltarea:TStringList;
        i:integer;
        ip_profe:string;
    begin
        stltarea:=tstringlist.create;
        ip_profe:=Format(BUSCAR_IP_PROFE,[g_host_profesor]);
        ip_profe:=HallarDato(ip_profe);
        try
            aula:=QuitarAcentos(aula);
            if not DirectoryExists('/tmp/aulas_virtuales')then
               CreateDir('/tmp/aulas_virtuales');
            with stltarea do
                begin
                    Add('#!/bin/sh');
                    Add('# la ip del profesor virtual al /etc/hosts.allow de alumnos de su aula virtual');
                    for i:=0 to strtoint(cboNumOrd.text)-1 do
                        Add('#tarea_para:'+edord[i].text);
                    Add('PROFESOR_EXISTE=`grep -c "'+ip_profe+' # ip profesor_virtual" /etc/hosts.allow `');
                    Add('if [ $PROFESOR_EXISTE  = 0 ]; then');
                    Add('echo "ALL:'+ip_profe +' # ip profesor_virtual">>/etc/hosts.allow');
                    Add('fi');
                    SaveToFile('/tmp/aulas_virtuales/tarea_anadir_profesor_virtual_'+aula+'.sh');
                end;
            Ejecutar(pchar('chmod 777 /tmp/aulas_virtuales/tarea_anadir_profesor_virtual_'+aula+'.sh'))
        finally
            stltarea.Free;
        end;
    end;
procedure TfrmVirtual.LimpiarCampos();
    begin
        //Limpiamos y ocultatomos los equipos
        ocultarordenatas;
        LimpiarCampos1()
    end;
procedure TfrmVirtual.LimpiarCampos1();
    var
        i:integer;
    begin
        //Limpiamos el contenido de todos los edit;
        edaula.Text:='';
        cboNumOrd.Text:='';
        cboNumCol.text:='';
        for i:=low(ednombres) to high(ednombres) do
            begin
                ednombres[i].Text:='';
                edord[i].Text:='';
                edmac[i].Text:='';
            end;
    end;
initialization
  {$I aulavirtual.lrs}

end.

