{
  Aulalinex 3.0-7 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit capturador;

{$mode objfpc}{$H+}

interface

uses
  globales,globales1,textomensajes,Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Menus,
  ExtCtrls, StdCtrls, Buttons;

type

  { TfrmCapturador }

  TfrmCapturador = class(TForm)
    btnCerrar: TBitBtn;
    cboCapturas: TComboBox;
    imgPresenta: TImage;
    imgFondo: TImage;
    lblRaton: TLabel;
    pnPintar: TPanel;
    pnRaton: TPanel;
    pnPresenta: TPanel;
    shaGrosor: TShape;
    shaColor: TShape;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    spMano: TSpeedButton;
    spLinea: TSpeedButton;
    spMostrar: TSpeedButton;
    spOcultar: TSpeedButton;
    spPintar: TSpeedButton;
    spCursor: TSpeedButton;
    spNuevo: TSpeedButton;
    spRefrescar: TSpeedButton;
    spGuardar: TSpeedButton;
    spEliminar: TSpeedButton;
    spSubMano: TSpeedButton;
    sbSubLinea: TSpeedButton;
    procedure btnCerrarClick(Sender: TObject);
    procedure cboCapturasChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure imgPresentaMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imgPresentaMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure imgPresentaMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sbSubLineaClick(Sender: TObject);
    procedure spCursorClick(Sender: TObject);
    procedure spEliminarClick(Sender: TObject);
    procedure spGuardarClick(Sender: TObject);
    procedure spLineaClick(Sender: TObject);
    procedure spManoClick(Sender: TObject);
    procedure spMostrarClick(Sender: TObject);
    procedure spNuevoClick(Sender: TObject);
    procedure spOcultarClick(Sender: TObject);
    procedure spPintarClick(Sender: TObject);
    procedure spRefrescarClick(Sender: TObject);
    procedure spSubManoClick(Sender: TObject);
  private
    procedure ActivarPintar();
    procedure ActivarSub();
    procedure AlumnoRatonNo(nord: integer);
    procedure AlumnoRatonSi(nord: integer);
    procedure BuscaFicheros(Ruta, Mascara: AnsiString; brec: Boolean);
    procedure CargarImagen(sArc: string;tipo:integer);
    procedure ColocarImagen();
    procedure ColocarShape;
    procedure ColorClick(Sender: TObject);
    procedure CrearDarRaton;
    procedure CrearPintar();
    procedure HacerPintar(amano: boolean);
    procedure HacerSubRayar(amano: boolean);
    procedure LineaClick(Sender: TObject);
    procedure OcultarPresenta();
    procedure spdarratonclick(sender: Tobject);
    procedure TodosPresentar();
    { private declarations }
  public
    { public declarations }
  end; 

var
  frmCapturador: TfrmCapturador;
  lbllinea:array[1..10] of Tlabel;
  lblColorLin:array[1..10] of Tlabel;
  lblSub:array[1..4] of Tlabel;
  lblColorSub:array[1..4] of Tlabel;
  spDarRaton:Array of TspeedButton;

implementation
const
    COLORES_PINTAR:array[1..10]of TColor=(clblack,clgray,clNavy,clblue,clgreen,clred,clfuchsia,
                            $00FFAA00,clyellow,clwhite);
    COLORES_SUBRAYAR:Array[1..4] of Tcolor=($00FFC0FE,clAqua,$0000E200,clYellow);

var
    f_AmoRaton:integer=-1;
    f_xi,f_xf,f_yi,f_yf:integer;
    f_Activado:boolean;
    f_Pintando:boolean;
    f_Drawing: Boolean;
    f_LastPos: TPoint;
    f_Mano,bPinchado:boolean;
    f_DarRaton:Array of boolean;
    f_anchoImg,f_altoImg:word;

{ TfrmCapturador }
Procedure TfrmCapturador.TodosPresentar();
    var
        i:integer;
    begin
        iniciarServidorVNC();
        application.ProcessMessages;
        for i:=0 to high(equipoalumno) do
                 equipoalumno[i].mostrar()
    end;

procedure TfrmCapturador.spdarratonclick(sender:Tobject);
    var
        i,nor:integer;
    begin
        nor:=(sender as Tspeedbutton).tag;
        if f_DarRaton[nor]=false then
            begin
                for i:=low(f_darRaton) to high(f_DarRaton) do
                   f_DarRaton[i]:=false;
                application.ProcessMessages;
                lblraton.Caption:='Ratón: '+equipoalumno[nor].NombreMonitor;
                lblraton.Visible:=true;
                f_DarRaton[nor]:=true;
                AlumnoRatonSi(nor);
            end
        else
            begin
                f_DarRaton[nor]:=false;
                AlumnoRatonNo(nor);
                lblraton.Visible:=false;
            end;
    end;

procedure TfrmCapturador.OcultarPresenta();
    var
        i:integer;
    begin
        CerrarServidorVnc;
        for i:=0 to high(f_DarRaton) do
            begin
                spdarraton[i].down:=false;
                f_DarRaton[i]:=false;
            end;
        application.ProcessMessages;
        IniciarServidorVnc;
        g_MostrandoPantalla:=0;
    end;
procedure TfrmCapturador.LineaClick(Sender: TObject);
    begin
        imgPresenta.Canvas.Pen.Width:=strtoint((sender as Tlabel).caption);
        shagrosor.Left:=(sender as Tlabel).Left -1 ;
        shagrosor.top:=(sender as Tlabel).top -1
    end;

procedure TfrmCapturador.HacerSubRayar(amano: boolean);
    begin
        if lblcolorsub[1].Enabled=false then
            begin
                imgPresenta.Canvas.Pen.Width:=20;
                imgPresenta.Canvas.Pen.Color:=$00FEC0FF;
                shagrosor.Left:= lblsub[1].Left-1;
                shagrosor.Top:=lblsub[1].Top-1;
                shacolor.Left:= lblcolorsub[1].Left-1;
                shacolor.Top:=lblcolorsub[1].Top-1
            end;
        ActivarSub;
        imgPresenta.Canvas.Pen.Mode:=pmnotxor;
        imgpresenta.Cursor:=crIBeam;
        f_Mano:=amano;
    end;

Procedure TfrmCapturador.HacerPintar(amano:boolean);
    begin
        if lblcolorlin[1].Enabled=false then
            begin
                imgPresenta.Canvas.Pen.Width:=1;
                imgPresenta.Canvas.Pen.Color:=clblack;
                ColocarShape;
            end;
        ActivarPintar;
        f_Mano:=amano;
        imgPresenta.Canvas.Pen.Mode:=pmCopy;
        imgpresenta.Cursor:=crArrow;
    end;

procedure TfrmCapturador.CrearPintar();
    var
        i:integer;
        tbl:integer;
    begin
        for i:=1 to 10 do
          begin
              tbl:=41+(i-1)*26;
              lbllinea[i]:=Tlabel.Create(self);
              with lbllinea[i] do
                  begin
                      Caption:=inttostr(i);
                      AutoSize:=false;
                      Color:=clwhite;
                      Transparent:=false;
                      Tag:=i;
                      borderstyle:=bsSingle;
                      alignment:=tacenter;
                      Layout:=tlcenter;
                      Font.Name:='Sans';
                      Font.Size:=11;
                      visible:=true;
                      SetBounds(10,tbl,24,24);
                      Onclick:=@lineaclick;
                      enabled:=false;
                      Parent:=pnpintar;
                      visible:=true;
                  end;
              lblColorLin[i]:=Tlabel.Create(self);
              with lblColorLin[i] do
                  begin
                      Caption:='';
                      AutoSize:=false;
                      Transparent:=false;
                      Tag:=i;
                      enabled:=false;
                      borderstyle:=bsSingle;
                      color:=COLORES_PINTAR[i];
                      SetBounds(46,tbl,24,24);
                      Onclick:=@colorclick;
                      Parent:=pnpintar;
                      visible:=true;
                  end;
          end;
             for i:=1 to 4 do
             begin
               tbl:=347+(i-1)*26;
              lblSub[i]:=Tlabel.Create(self);
              with lblsub[i] do
                  begin
                      Caption:=inttostr(15+i*5);
                      AutoSize:=false;
                      Color:=clwhite;
                      Transparent:=false;
                      Tag:=i;
                      borderstyle:=bsSingle;
                      alignment:=tacenter;
                      Layout:=tlcenter;
                      Font.Name:='Sans';
                      Font.Size:=11;
                      SetBounds(10,tbl,24,24);
                      enabled:=false;
                      Onclick:=@lineaclick;
                      Parent:=pnpintar;
                      visible:=true;
                  end;
               lblColorSub[i]:=Tlabel.Create(self);
               with lblColorSub[i] do
                  begin
                      Caption:='';
                      AutoSize:=false;
                      Transparent:=false;
                      Tag:=i;
                      borderstyle:=bsSingle;
                      enabled:=false;
                      color:=COLORES_SUBRAYAR[i];
                      SetBounds(46,tbl,24,24);
                      Onclick:=@colorclick;
                      Parent:=pnpintar;
                      visible:=true;
                  end;
              end
    end;
procedure TfrmCapturador.CrearDarRaton;
    var
        i:integer;
    begin
        setlength(spdarraton,g_num_ord_aula);
        setlength(f_DarRaton,g_num_ord_aula);
        for i:=0 to g_num_ord_aula-1 do
                    f_DarRaton[i]:=false;
        for i:= 0 to g_num_ord_aula-1 do
            begin
                spdarraton[i]:= TspeedButton.Create(self);
                with spdarraton[i] do
                    begin
                        GroupIndex:=101;
                        Down:=false;
                        AllowAllUp:=true;
                        Visible:=true;
                        SetBounds(3+22*i,3,22,22);
                        margin:=3;
                        font.Name:='Sans';
                        font.Size:=12;
                        Layout:=blGlyphLeft;
                        Parent:=pnRaton;
                        tag:=i;
                        Cursor:=crarrow;
                        Transparent:=true;
                        OnClick:=@spdarratonclick;
                        ShowHint:=true;
                        Caption:=inttostr(i+1);
                        with equipoalumno[i] do
                            begin
                                if EstadoActivadEquipo in [eUsuario,eEncendido] then
                                    Enabled:=true
                                else
                                    Enabled:=false;
                                if Enabled then
                                        Hint:= NombreMonitor
                                else
                                 Hint:= NombreMonitor+'-Apagado';

                            end;
                        visible:=true;
                    end;
            end;
        pnraton.width:=22*g_num_ord_aula+10;
        pnraton.height:=32
    end;
procedure TfrmCapturador.ColorClick(Sender: TObject);
    begin
        imgPresenta.Canvas.Pen.Color:=(sender as Tlabel).Color;
        shaColor.Left:=(sender as Tlabel).Left -1;
        shaColor.top:=(sender as Tlabel).top -1
    end;
procedure TfrmCapturador.ColocarShape;
    begin
        shagrosor.Left:= lbllinea[1].Left-1;
        shagrosor.Top:=lbllinea[1].Top-1;
        shacolor.Left:=lblcolorlin[1].Left-1;
        shacolor.Top:=lblcolorlin[1].Top-1;
    end;

Procedure TfrmCapturador.ColocarImagen();
    begin
        imgpresenta.autosize:=true;
        imgpresenta.Stretch:=false;
        imgpresenta.setbounds(0,0,1024,768);
        imgpresenta.Visible:=true;
    end;
procedure TfrmCapturador.CargarImagen(sArc:string;tipo:integer);
    var
       bmp:TBitmap;
       png:TPortableNetworkGraphic;
    begin
        imgpresenta.Width:=0;
        imgpresenta.height:=0;
        application.ProcessMessages;
        imgpresenta.Visible:=false;
        try
            imgpresenta.Picture.Bitmap.clear;
            case tipo of
                0:
                    begin
                        png:=TPortableNetworkGraphic.create;
                        try
                            DimensionPNG(sArc,f_anchoImg,f_altoImg);
                            png.loadfromfile(sArc);
                            imgpresenta.Picture.Bitmap.Assign(png);
                        finally
                            png.Free;
                        end;
                    end;
                1:
                    begin
                        bmp:=TBitmap.create;
                        try
                            DimensionBMP(sArc,f_anchoImg,f_altoImg);
                            bmp.loadfromfile(sArc);
                            imgpresenta.Picture.Bitmap.Assign(bmp);
                        finally
                            bmp.Free;
                        end;
                    end;
             end;
            imgpresenta.width:=f_anchoImg;
            imgpresenta.height:=f_altoimg;
            sppintar.Enabled:=not pnpintar.visible;
            pnraton.Visible:= not spmostrar.Enabled;
            spcursor.Enabled:= pnpintar.visible;
        except
            begin
                mensaje(MEN_ERROR_ARCHIVO,aceptar);
                exit;
            end;
        end;
          application.ProcessMessages;
          colocarimagen;
    end;
procedure TfrmCapturador.BuscaFicheros(Ruta, Mascara : AnsiString; brec : Boolean);
    var
        srBuscar : TSearchRec;
        iEncontrado : Integer;
    begin
        cboCapturas.clear;
        if Ruta[Length(Ruta)] <> '/' then Ruta := Ruta +'/';
        iEncontrado := FindFirst(Ruta+Mascara, faAnyFile-faDirectory, srBuscar);
        while iEncontrado = 0 do
            begin
                if ( srBuscar.Name <> '.' ) and ( srBuscar.Name <> '..' ) and ( srBuscar.Name <> '' ) then
                cbocapturas.items.Add(srBuscar.Name);
                iEncontrado := FindNext(srBuscar);
            end;
        FindClose(srBuscar);
        cbocapturas.Sorted:=true;
    end;



procedure TfrmCapturador.AlumnoRatonNo(nord:integer);
    begin
       equipoAlumno[nord].ratonNo();
        f_AmoRaton:=-1;
    end;

procedure TfrmCapturador.AlumnoRatonSi(nord:integer);
    begin
        if (f_AmoRaton<> -1) and (f_AmoRaton<>nord) then AlumnoRatonNo(f_AmoRaton);
        equipoAlumno[nord].raton();
        f_AmoRaton:=nord;
    end;

procedure TfrmCapturador.ActivarSub();
    var
        i:integer;
    begin
        for i:=1 to 10 do
            begin
                with lblcolorlin[i] do
                    begin
                        enabled:=false;
                        cursor:=crdefault;
                        showhint:=false;
                    end;
            end;
        for i:=1 to 10 do
            begin
                with lbllinea[i] do
                    begin
                        enabled:=false;
                        cursor:=crarrow;
                        showhint:=false;
                    end;
            end;
        for i:=1 to 4 do
            begin
                with lblcolorSub[i] do
                    begin
                        enabled:=true;
                        cursor:=crhandpoint;
                        showhint:=true;
                    end;
            end;
            for i:=1 to 4 do
            begin
                with lblSub[i] do
                    begin
                        enabled:=true;
                        cursor:=crhandpoint;
                        showhint:=true;
                    end;
            end;
    end;

procedure TfrmCapturador.ActivarPintar();
    var
        i:integer;
    begin
        for i:=1 to 10 do
            begin
                with lbllinea[i] do
                    begin
                        enabled:=true;
                        cursor:=crhandpoint;
                        showhint:=true;
                    end;
                with lblcolorlin[i] do
                    begin
                        enabled:=true;
                        cursor:=crhandpoint;
                        showhint:=true;
                    end;
            end;
        for i:=1 to 4 do
            begin
                with lblColorSub[i]do
                    begin
                        enabled:=false;
                        cursor:=crdefault;
                        showhint:=false;
                    end;
                with lblSub[i]do
                    begin
                        enabled:=false;
                        cursor:=crarrow;
                        showhint:=false;
                    end;
            end;
    end;
procedure TfrmCapturador.btnCerrarClick(Sender: TObject);
    begin
        CerrarServidorVnc;
        close;
        Application.ProcessMessages;
        IniciarServidorVnc;
    end;

procedure TfrmCapturador.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);
    begin
        CloseAction:=cafree;
    end;

procedure TfrmCapturador.FormCloseQuery(Sender: TObject; var CanClose: boolean);
    begin
        hide;
    end;

procedure TfrmCapturador.FormCreate(Sender: TObject);
    var
        sarchivo:string;
    begin
        left:=0;
        top:=0;
        Width:=0;
        Height:=0;
        setbounds(0,0,1024,768);
        pnpresenta.setbounds(8,8,1004,688);
        sarchivo:=equipoprofesor.ArcCaptura;
        if fileexists(sarchivo) then
            CargarImagen(sArchivo,0);
         g_EstoyPresentando:=true;
        CrearPintar;
        CrearDarRaton;
        bpinchado:=false;
        f_Mano:=true;
        spmano.OnClick(spmano);
        spmano.Down:=true;
        Activarsub;
        spPintarClick(spPintar);
        if g_MostrandoPantalla=0 then
            begin
                spmostrar.Enabled:=true;
                spocultar.Enabled:=false;
                application.ProcessMessages;
                pnraton.Visible:=false;
            end
        else
            begin
                spmostrar.Enabled:=false;
                spocultar.Enabled:=true;
                pnraton.Visible:=true;
            end;
        BuscaFicheros(equipoProfesor.DirCapturas,'*.png',TRUE);
        BorderStyle:=bsNone;
        Application.ProcessMessages;
        IniciarServidorVnc();
    end;

procedure TfrmCapturador.imgPresentaMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    begin
        if f_Pintando=false then
            begin
                if button = mbleft then
                    begin
                        f_xi:=X;
                        f_yi:=Y;
                        imgpresenta.Cursor:=crSizeall;
                        f_Activado:=true;
                    end;
            end
        else
            begin
                if f_Mano then
                    begin
                        if Button = mbLeft then
                            begin
                                f_Drawing := True;
                                f_LastPos := Point(x,y);
                            end;
                    end
                else
                    begin
                        if bpinchado=false then
                                begin
                                    bpinchado:=true;
                                    imgPresenta.Canvas.MoveTo(x,y);
                                end
                        else
                             begin
                                bpinchado:=false;
                                imgPresenta.Canvas.lineto(x,y);
                             end;
                    end;
            end;
    end;

procedure TfrmCapturador.imgPresentaMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
    begin
        if (not f_Pintando) and f_Activado then
            begin
                f_xf:=X;
                f_yf:=Y;
                imgpresenta.Left:=imgpresenta.Left +(f_xf-f_xi);
                imgpresenta.Top:= imgpresenta.top +(f_yf-f_yi);
                application.ProcessMessages;
            end
        else if f_Pintando and f_Drawing and f_Mano then
            begin
                imgPresenta.Canvas.MoveTo(f_LastPos.X, f_LastPos.Y);
                f_LastPos := Point(x,y);
                imgPresenta.Canvas.LineTo(f_LastPos.X, f_LastPos.Y);
            end;
    end;

procedure TfrmCapturador.imgPresentaMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    begin
        if f_Pintando=false then
            begin
                if button = mbleft then
                    begin
                        f_xf:=X;
                        f_yf:=Y;
                        imgpresenta.Cursor:=crarrow;
                        imgpresenta.Left:=imgpresenta.Left +(f_xf-f_xi);
                        imgpresenta.Top:= imgpresenta.top +(f_yf-f_yi);
                        f_Activado:=false;
                    end;
            end
        else
            if f_Mano and (Button = mbLeft) then
                f_Drawing := False;
    end;

procedure TfrmCapturador.sbSubLineaClick(Sender: TObject);
    begin
        bPinchado:=false;
        HacerSubrayar(false);
    end;

procedure TfrmCapturador.spCursorClick(Sender: TObject);
    begin
        f_Pintando:=false;
        imgpresenta.Cursor:=crarrow;
        pnpintar.Visible:=false;
        sppintar.Enabled:=true;
        spcursor.Enabled:=false;
    end;

procedure TfrmCapturador.spEliminarClick(Sender: TObject);
    var
        borrar:string;
    begin
        if mensaje(MEN_LIMPIAR_CAPTURAS,sino)=2 then exit;
        application.processmessages;
        if trim(equipoProfesor.DirCapturas)=' ' then exit;
        borrar:= 'rm ' + equipoProfesor.DirCapturas+'/*';
        Ejecutar(borrar);
          if fileexists(equipoProfesor.ArcCaptura) then
                      CargarImagen(equipoProfesor.ArcCaptura,0);
        BuscaFicheros(equipoProfesor.DirCapturas,'*.png',TRUE);
        cboCapturas.text:='';
    end;

procedure TfrmCapturador.spGuardarClick(Sender: TObject);
    var
        fichero,fecha,hora:string;
    begin
        DateSeparator := '-';
        ShortDateFormat := 'yyyy/mm/dd/';
        fecha := DateToStr(date);
        TimeSeparator:='-';
        hora:=timetostr(time);
        fichero:=equipoProfesor.DirCapturas+'/captura_'+fecha+hora+'.png';
        fichero:=stringreplace(fichero,'-','',[rfReplaceAll]);
        if mensaje('El archivo se guardara como' +fichero+'. ¿Desea continuar?',sino)=2 then exit;
        if not fileexists(fichero) then             begin
                application.processmessages;
                imgpresenta.picture.bitmap.savetofile(fichero);
                BuscaFicheros(equipoProfesor.DirCapturas,'*.png',TRUE);
                cboCapturas.text:='';
            end

    end;

procedure TfrmCapturador.spLineaClick(Sender: TObject);
    begin
        bpinchado:=false;
        HacerPintar(false);
    end;

procedure TfrmCapturador.spManoClick(Sender: TObject);
    begin
        HacerPintar(true);
    end;

procedure TfrmCapturador.spMostrarClick(Sender: TObject);
    begin
        enabled:=false;
        spmostrar.Enabled:=false;
        application.ProcessMessages;
        TodosPresentar;
        spocultar.Enabled:=true;
        enabled:=true;
        pnraton.Visible:=true;
    end;

procedure TfrmCapturador.spNuevoClick(Sender: TObject);
    var
        micolor:Tcolor;
    begin
        micolor:=imgPresenta.Canvas.Pen.Color;
        imgPresenta.Canvas.Pen.Color:=clwhite;
        imgPresenta.picture.bitmap.canvas.rectangle(0,0,1024,768);
        imgPresenta.Canvas.Pen.Color:=micolor;
    end;
procedure TfrmCapturador.spOcultarClick(Sender: TObject);
    begin
        OcultarPresenta;
        spmostrar.Enabled:=true;
        spocultar.Enabled:=false;
        application.ProcessMessages;
        pnraton.Visible:=false;
        lblRaton.Visible:=false;
    end;

procedure TfrmCapturador.spPintarClick(Sender: TObject);
    begin
        f_Pintando:=true;
        imgpresenta.Cursor:=crdrag;
        f_Drawing:=false;
        pnpintar.Visible:=true;
        pnpintar.Enabled:=true;
        pnpintar.BorderStyle:=bsSingle;
        sppintar.Enabled:=false;
        spcursor.Enabled:=true;
        HacerPintar(true);
    end;

procedure TfrmCapturador.spRefrescarClick(Sender: TObject);
    begin
        if fileexists(equipoProfesor.ArcCaptura) then
            CargarImagen(equipoProfesor.ArcCaptura,0);
    end;

procedure TfrmCapturador.spSubManoClick(Sender: TObject);
    begin
        HacerSubrayar(true);
    end;
procedure TfrmCapturador.cboCapturasChange(Sender: TObject);
    var
        archivo:string;
    begin
        if cbocapturas.text <>'' then
            begin
                archivo:=equipoProfesor.DirCapturas+PathDelim+cbocapturas.items[cboCapturas.ItemIndex];
                if fileexists(archivo) then
                    CargarImagen(archivo,1);
            end
    end;




initialization
  {$I capturador.lrs}

end.

