{
  Aulalinex 3.0-7 Software de gestión de Aulas Tecnológicas
  Copyright (C) 2008-2009, Consejería de Educación,Junta de Extremadura
  Programación: Manuel Narváez Martínez  <mnarvaez007@gmail.com>
  Diseño gráfico: Ana María Zamora Moreno
  Desarrollado con Lazarus 0.9.26

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit clhallardatos;

{$mode objfpc}{$H+}

interface

uses
unix,Classes,IniFiles,StrUtils,SysUtils,IdTCPClient;

type

  Tdatosequipos =record
         numequipos:integer;
         nombre:array of string;
         ip:array of string;
         mac:array of string;
     end;
  { ThrHallarDatos }

  ThrHallarDatos = class(TThread)
  private
    { Private declarations }

        fnumequipos:integer;
        faula,fcomando:string;
        faula0:string;
        fpuerto:integer;
        fcliente:TIdTcpClient;
        fmisequiposdns:Tdatosequipos;
        fmisequiposldap:Tdatosequipos;
        fgateway:string;
        procedure EscribirSetupIni();
        function HallaNumEquipos(): integer;
        function HallarMacIps():Boolean;
        function HallarDato3(Cmd:string):String;
        Function NumOrdLet(num:integer):string;
  protected
        procedure Execute; override;
  public
       constructor Create(maula,gateway:string);
  end;

implementation

constructor ThrHallarDatos.Create(maula,gateway:string);
  var
     i:integer;
  begin
      inherited Create(true);
      faula0:=maula;
      faula:=maula+'-o';
      FreeOnTerminate:=True;

  end;

procedure ThrHallarDatos.Execute;
    var
       equiposhallados:boolean;
    begin
        try
            equiposhallados:=false;
            fnumequipos:= HallaNumEquipos();
            fmisequiposldap.numequipos:=fnumequipos;
            if fnumequipos=0 then
                begin
                     //writeln('Numero equipos del aula devueltos por ldap: ' + inttostr(fmisequiposldap.numequipos));
                end
            else
                begin
                   // writeln('Numero equipos del aula devueltos por ldap: ' + inttostr(fmisequiposldap.numequipos));
                    equiposhallados:=HallarMacIps();
                    if  equiposhallados then
                    begin
                        //writeln('Número equipos hallados en dnsmasq.leases: ' + inttostr(fmisequiposdns.numequipos));
                        EscribirSetupIni();
                    end;
                end;
        except
              //writeln('Execute: Error al hallar datos');
        end;
    end;
Procedure ThrHallarDatos.EscribirSetupIni();
    var
        ipvlc:string;
         Ordbool:boolean;
        Mifichero:TMemIniFile;
        i,b,c,ndisAula:integer;
    begin
        Mifichero:= TMemIniFile.create('/var/lib/aulalinex-profesor-ltsp/temp_setup.ini');
        try
          try
          b:=random(255);c:=0;
          ipvlc:='239.255.'+inttostr(b)+'.'+inttostr(c);
          with MIfichero do
              begin
                  WriteString('Aula','Aula',faula0+'-');
                  WriteString('Aula','Numero Filas','3');
                  WriteString('Aula','Numero Ordenadores',inttostr(fmisequiposldap.numequipos));
                  WriteString('Profesor','mesa profesor',faula0+'-pro');
                  WriteString('Profesor','mesa alumno',faula0+'-o');
                  WriteInteger('TipoClase','Tipo',0);
                  WriteString('TipoClase','Inicio','1');
                  WriteString('Alumno','alumno','aulalinex-alumno');
                  WriteString('Servidor','IP','192.168.0.254');
                  WriteString('Vlc','IP',ipvlc);
                  writebool('Internet','Internet desactivado',false);
                  writebool('RatonTeclado','RatonTeclado inactivos',false);
                  WriteInteger('Diseno','Tipo',0);
                  writebool('Canon','Activo',false);
                  WriteInteger('Canon','Tiempo',20);
                  for i:=0 to fmisequiposldap.numequipos-1 do
                      begin
                          ordbool:= true;
                          WriteString ('Mesas','Mesa '+NumOrdLet(i),trim(fmisequiposldap.nombre[i]));
                          WriteString ('MAC','Mesa '+NumOrdLet(i),trim(fmisequiposldap.mac[i]));
                          WriteString ('IPS','Mesa '+NumOrdLet(i),trim(fmisequiposldap.ip[i]));
                          WriteString ('Estado','Mesa '+NumOrdLet(i),booltostr(ordbool));
                      end;
                  UpdateFile;
              end;
              unix.fpSystem('chmod 644 /var/lib/aulalinex-profesor-ltsp/temp_setup.ini')
              except
                  begin
                      // writeln('EscribirSetupIni: Error al excribir datos');
                  end;
              end;
          finally
              Mifichero.free;
          end;
    end;
Function ThrHallarDatos.NumOrdLet(num:integer):string;
    var
        letraord:string;
    begin
        num:=succ(num);
        letraord:=ifthen(num<10,'0'+inttostr(num),inttostr(num));
        result:=letraord;
    end;
function ThrHallarDatos.HallarMacIps():Boolean;
    var
        mies,fnumdns,i,j:integer;
        miequipoldap:string;
        laip,lamac:String;
        nnombremacsldap,nipmacsdns:integer;
        misipsmacdns:TstringList;
        comando,cnombremacsldap,cipmacsdns,grupoipmacdns:string;
        numequipomax:integer;
    begin
        numequipomax:=0;
        result:=true;
        cipmacsdns:='cat /var/lib/dhcp3/dhcpd.leases | grep -v leases | grep -v starts | grep -v ends | grep -v cltt| grep -v tstp | grep -v binding | grep -v "#" | grep -v grep| grep -v "}"| tr "\n" " " | tr -s " " | tr ";" "\n" | cut -f3,7 -d" " | grep 192 | sort | uniq';
        cnombremacsldap:='ldapsearch -xLLL -h ldap -b dc=instituto,dc=extremadura,dc=es "(&(objectClass=dhcpHost)(cn=%s))"| grep dhcpHW | awk ' + QuotedStr('{print $3}');
        try
            misipsmacdns:=TstringList.Create;
            try
                misipsmacdns.text:=HallarDato3(cipmacsdns);
                fmisequiposdns.numequipos:= misipsmacdns.Count;
              //  writeln('numero equipos en dnsmasq,incluido 200: '+  inttostr(fmisequiposdns.numequipos));
                if  (fmisequiposdns.numequipos = 0)  then
                    begin
                        result:=false;
                        exit;
                    end;
                setlength(fmisequiposdns.ip,fmisequiposdns.numequipos);
                setlength(fmisequiposdns.mac,fmisequiposdns.numequipos);
                setlength(fmisequiposdns.nombre,fmisequiposdns.numequipos);
                for i:=0 to fmisequiposdns.numequipos -1 do
                    begin
                        grupoipmacdns:=Trim(misipsmacdns.Strings[i]);
                       // writeln(grupoipmacdns);
                        mies:=pos(' ',grupoipmacdns);
                       // writeln(mies);
                        if ((mies>0)) then
                            begin
                                fmisequiposdns.ip[i]:=LeftStr(grupoipmacdns, mies);
                                fmisequiposdns.mac[i]:=Rightstr(grupoipmacdns, length(grupoipmacdns)-mies);
                                fmisequiposdns.mac[i]:=UpperCase(fmisequiposdns.mac[i]);
                            end
                        else
                            begin
                                fmisequiposdns.ip[i]:='192.168.0';
                                fmisequiposdns.mac[i]:='00:00:00:00:00:00';
                            end;
                    end;
                setlength(fmisequiposldap.ip,fmisequiposldap.numequipos);
                setlength(fmisequiposldap.mac,fmisequiposldap.numequipos);
                setlength(fmisequiposldap.nombre,fmisequiposldap.numequipos);
                for i:=0 to fmisequiposldap.numequipos -1 do
                    begin
                        laip:='';
                        lamac:='';
                        miequipoldap:='';
                        if (i<9) then
                             miequipoldap:=faula+'0'+inttostr(i+1)
                        else
                             miequipoldap:=faula+inttostr(i+1);
                        //writeln(miequipoldap);
                        comando:= Format(cnombremacsldap,[miequipoldap]);
                        lamac:=HallarDato3(comando);
                        lamac:=UpperCase(lamac);
                        for j:=0 to fmisequiposdns.numequipos -1 do
                            begin
                                //writeln('soy el equipo ' +miequipoldap + ' mi mac es ' + lamac + ' y estoy probando contra ' + fmisequiposdns.mac[j]);
                                if lamac=fmisequiposdns.mac[j]   then
                                    begin
                                        laip:=fmisequiposdns.ip[j];
                                        numequipomax:=i;
                                        break;
                                    end;
                            end;
                          sleep(100);
                     //writeln('soy el equipo ' +miequipoldap + ' mi ip es ' + laip + ' y mi mac ' + lamac);
                      if lamac='' then lamac:='00:00:00:00:00:00';
                      if laip='' then laip:='192.168.0';
                      fmisequiposldap.nombre[i]:=miequipoldap;
                      fmisequiposldap.mac[i]:=lamac;
                      fmisequiposldap.ip[i]:=laip;
                     end;
                fmisequiposldap.numequipos:=numequipomax+1;
                if fmisequiposldap.numequipos > 18 then
                    fmisequiposldap.numequipos:=18;
                 setlength(fmisequiposldap.ip,fmisequiposldap.numequipos);
                 setlength(fmisequiposldap.mac,fmisequiposldap.numequipos);
                 setlength(fmisequiposldap.nombre,fmisequiposldap.numequipos);
          finally
                 misipsmacdns.free;
          end;
    except
         //writeln('HallarMacIps: Errora al calcular ip-mac dns o ldap');
         result:=false;

    end;
end;
function ThrHallarDatos.HallaNumEquipos():integer;
    var
        saula,numequ,comando:string;
        nnumequ:integer;
    begin
       try
       comando:='ldapsearch -xLLL -h ldap -b dc=instituto,dc=extremadura,dc=es "(&(objectClass=dhcpHost)(cn=%s))"| grep -c dhcpHW';
       saula:=faula+'*';
       comando:= Format(comando,[saula]);
       numequ:=HallarDato3(comando);
      // nnumequ:=0;
       if trim(numequ)<>'' then
           begin
               nnumequ:=strtoint(numequ);
           end;
        result:=nnumequ;
      except
        //writeln('HallarDatos: Error al hallar numero equipos en consulta ldap');
        result:=0;
      end;
    end;
function ThrHallarDatos.HallarDato3(Cmd:string):String;
    var
        file1: TextFile;
        s,t: ansistring;
        n: longint;
        j:integer;
    begin
        try
            j:=0;
            n:=popen(file1, Cmd, 'r');
            if n=-1 then
                begin
                    result:='';
                    Exit;
                end;
            t:='';
            while not eof(file1) do begin
                Readln(File1,s);
                t:=t+s+Chr(10);
                inc(j);
            end;
            pclose(file1);
            result := trim(t);
        except
           // writeln('HallarDato3: Error al leer  consola');
            result:='';
        end;
    end;

end.

