unit clservidor;

{$mode objfpc}{$H+}

interface

uses
  unix,Classes, SysUtils,StrUtils,IniFiles,process,clhallardatos;
type

   { Tservidor }

   Tservidor = class
      private
        fAula:String;
        fIP:String;
        fMAC:string;
        fHost:string;
        fGateway:string;
        fIPVLC:string;
        fInternetDesactivado:integer;
        fRatonTecladoDesactivado:integer;
        fIpMesa1:string;
        procedure LeerSetupIni(archivo:string);
        function NumOrdLet(num: integer): string;
        function ObtenerAula():string;
        function ObtenerMiIp():string;
        function ObtenerMiMAC():string;
        function HallarGateway():string;



      public
        constructor create (archivoini:string='/var/lib/aulalinex-profesor-ltsp/setup.ini');
        property IP:String read fIP;
        property MAC:String read fMAC;
        property Host:String read fHost;
        property Gateway:String read fGateway write fGateway;
        property IPVLC:String read fIPVLC write fIPVLC;
        property InternetDesactivado:integer read fInternetDesactivado write fInternetDesactivado;
        property RatonTecladoDesactivado:integer read fRatonTecladoDesactivado write fRatonTecladoDesactivado;
        function ObtenerHost():string;
        procedure Ejecutar(comando: string);
        function HallarDato(Cmd: string): string;

   end;

implementation
uses globales;
function Tservidor.ObtenerHost():string;
    const
         ORD_HOST:string='hostname | cut -f1 -d"."';
    begin
         result:=HallarDato(ORD_HOST);
    end;
function Tservidor.ObtenerAula():string;
    const
         ORD_AULA:string='hostname | cut -f1 -d"-"';
    begin
         result:=HallarDato(ORD_AULA);
    end;

procedure Tservidor.Ejecutar (comando:string);
    begin;
          unix.fpSystem(comando);
    end;
function Tservidor.HallarDato(Cmd:string):String;
    var
        file1: TextFile;
        s,t: ansistring;
        n: longint;
        j:integer;
    begin
        try
         j:=0;
        n:=popen(file1, Cmd, 'r');
        if n=-1 then
            begin
                result:='';
                Exit;
            end;
        t:='';
        while not eof(file1) do begin
            Readln(File1,s);
            t:=t+s+Chr(10);
            inc(j);
        end;
        pclose(file1);
        result := trim(t);
        except
            result:='';
        end;
    end;

constructor Tservidor.create(archivoini:string='/var/lib/aulalinex-profesor-ltsp/setup.ini');
    const
         ANADIR_VLC_ROUTER:string= '/sbin/route add -net %s/24 gw %s &';
    var
         orden_vlc:string;
    begin
        inherited create;
          fInternetDesactivado:=0;
          fRatonTecladoDesactivado:=0;
          fIP:=ObtenerMiIP();
          fMAC:=ObtenerMiMAC();
          fGateway :=HallarGateway();
          fIPVLC:='239.255.255.0';
          fHost:=ObtenerHost();
          fAula:=ObtenerAula();

           if FileExists(archivoini) then
              LeerSetupIni(archivoini);
           orden_vlc:=Format(ANADIR_VLC_ROUTER ,[fIPVLC,fGateway]);
           Ejecutar(orden_vlc);
           if   fIpMesa1 ='192.168.0.1' then
              begin
                  with ThrHallarDatos.create(fAula,fGateway) do Resume;
              end;

    end;

procedure Tservidor.LeerSetupIni(archivo:string);
    var
        FicheroIni:TMemIniFile;
        i:integer;
    begin
        try
            FicheroIni:=TMemIniFile.create(archivo);
            try
               with FicheroIni do
                   begin
                      g_num_ord_aula:=strtoint(ReadString('Aula','Numero Ordenadores','12'));
                      setlength(g_ips_equipos,g_num_ord_aula);
                      for i:=0 to g_num_ord_aula-1 do
                          begin
                              g_ips_equipos[i]:=ReadString('IPS','Mesa '+ NumOrdLet(i),'192.168.0.1');
                          end;
                      fInternetDesactivado:=ReadInteger('Internet','Internet desactivado',0);
                      fRatonTecladoDesactivado:=ReadInteger('RatonTeclado','RatonTeclado inactivos',0);
                      fGateway :=ReadString('Servidor','IP','');
                      g_programa_gestion:=ReadBool('GestionAula','Programa Aula Necesario',false);
                      if length(fGateway)< 5 then fGateway:=HallarGateway();
                      fIPVLC:=ReadString('Vlc','IP','');
                      if length(fIPVLC)< 10 then fIPVLC:='239.255.255.0';
                      fIpMesa1:=ReadString('IPS', 'Mesa 01','');
                   end;
            finally
                FicheroIni.free;
            end;
        except
            //writeLn('Error al cargar datos');
        end;
    end;
Function Tservidor.NumOrdLet(num:integer):string;
    var
        letraord:string;
    begin
        num:=succ(num);
        letraord:=ifthen(num<10,'0'+inttostr(num),inttostr(num));
        result:=letraord;
    end;
function Tservidor.ObtenerMiIp():string;
    const
        HALLAR_TARJETA:string='grep ^iface /etc/network/interfaces |grep static|head -1| tr -s " " |cut -f2 -d" "';
        ORD_IP:string= '/sbin/ifconfig %s | grep Bcast | cut -f2 -d: | cut -f1 -d" "|tail -1';
    var
        tarjeta_red:string;
        orden_ip:string;
        mip:string;
    begin
        mip:=trim(HallarDato('echo $LTSP_CLIENT'));
        if mip='' then
            begin
                tarjeta_red:=HallarDato(HALLAR_TARJETA);
                orden_ip:=Format(ORD_IP,[tarjeta_red]);
                mip:=Hallardato(orden_ip);
            end;
        result:=mip;
    end;
function Tservidor.ObtenerMiMAC():string;
    const
        ORD_MAC:string='/sbin/ifconfig | grep Ethernet |head -1 | tr -s " " | cut -f5 -d" "';
    begin
        result:=Hallardato(ORD_MAC);
    end;

function Tservidor.HallarGateway (): string ;
    const
        ORDEN_GATEWAY:STRING='/sbin/route -n| grep UG |grep "0.0.0.0"| tr -s " " | cut -f2 -d" "';
    begin
        result:=HallarDato(ORDEN_GATEWAY);
    end ;

end.


