unit demonio ;

{$mode objfpc}{$H+}

interface 

uses 
  clservidor,globales,Classes , SysUtils , FileUtil , LResources , Forms , Controls , Dialogs ,
  IdCmdTCPServer, IdCommandHandlers, IdContext, IdURI;

type 

  { TDataModule1 }
  TDataModule1 = class (TDataModule )
    IdCmdTCPServer1 : TIdCmdTCPServer ;
    procedure activarInternetCommand (ASender : TIdCommand );
    procedure apagarEquipoCommand (ASender : TIdCommand );
    procedure cierraUsuarioCommand(ASender: TIdCommand);
    procedure DataModuleCreate(Sender: TObject);
    procedure desactivarInternetCommand (ASender : TIdCommand );
    procedure hallarGatewayCommand (ASender : TIdCommand );
    procedure hallarHostCommand(ASender: TIdCommand);
    procedure hallarHostMacCommand(ASender: TIdCommand);
    procedure hallarIPCommand (ASender : TIdCommand );
    procedure hallarMACCommand (ASender : TIdCommand );
    procedure IdCmdTCPServer1AfterCommandHandler(ASender: TIdCmdTCPServer;
      AContext: TIdContext);
    procedure reiniciaServerAlumnoCommand(ASender: TIdCommand);
  private
    procedure IniciarDemonio(iport: integer; ihost: string);
    function ObtenerPuerto(ipequipo: string): String;

    { private declarations }
  public 
    { public declarations }
  end ; 

var 
  DataModule1 : TDataModule1 ; 

implementation 

{ TDataModule1 }

procedure TDataModule1.hallarIPCommand (ASender : TIdCommand );
    begin
       Asender.Reply.SetReply(301,miservidor.IP);
       ASender.SendReply;
    end;

procedure TDataModule1.apagarEquipoCommand (ASender : TIdCommand );
    const
        ORDEN_APAGAR:string='killall -9 x-session-manager;/sbin/poweroff -hp &';
    begin
        try
            Ejecutar1(ORDEN_APAGAR);
            Asender.Reply.SetReply(302,'Apagando equipo');
            ASender.SendReply;
            if IdCmdTCPServer1.Active then IdCmdTCPServer1.Active:=false;
            Application.Terminate;
        except
            //writeln('Error al apagar equipo');
        end;
    end;

procedure TDataModule1.cierraUsuarioCommand(ASender: TIdCommand);
    const
         ORDEN_CERRAR_USUARIO:string='pkill -u %s &';
         ORDEN_CERRAR_TODOS_SERVERS:String='killall serveralumnolinex-ltsp &';
         ORDEN_CERRAR_TODOS_X11VNC:String='killall x11vnc &';
    var
         ordsuario:string;
         usuario:string;
    begin
        try
             if Asender.Params.Count=1 then
                 begin
                    usuario:= trim(Asender.Params[0]);
                    if usuario='xtodosx' then
                        begin
                            Ejecutar1(ORDEN_CERRAR_TODOS_SERVERS);
                            Ejecutar1(ORDEN_CERRAR_TODOS_X11VNC);
                        end
                    else
                        begin
                            if (usuario='root') or (usuario='nobody') or (usuario='avahi') or (usuario='pulse') or (usuario='100') then exit;
                            ordsuario:= Format(ORDEN_CERRAR_USUARIO,[usuario]);
                            Ejecutar1(ordsuario);
                        end
                 end
              else
                  begin
                      //writeln('Cerrar usuario: Orden o número parametros incorrectos');
                  end;
        except
            //writeln('Error al cerrar usuario');
        end;
    end;

procedure TDataModule1.DataModuleCreate(Sender: TObject);
begin
  IniciarDemonio(36999,'0.0.0.0');
end;

procedure TDataModule1.activarInternetCommand (ASender : TIdCommand );
    const
         ORDEN_ACTIVAR0:string='iptables-save| grep "owner %s"|head -1';
         ORDEN_ACTIVAR1:string='iptables %s 2>/dev/null';
    var
         datosorden:string;
         usuario:string;
    begin
        try
             if Asender.Params.Count=1 then
                 begin
                    usuario:= trim(Asender.Params[0]);
                    datosorden:=Format(ORDEN_ACTIVAR0,[usuario]);
                    datosorden:=HallarDato1(datosorden);
                    if datosorden ='' then exit;
                    datosorden:=StringReplace(datosorden, '-A ', '-D ',[rfReplaceAll]);
                    datosorden:= Format(ORDEN_ACTIVAR1,[datosorden]);
                    Ejecutar1(datosorden);
                    Asender.Reply.SetReply(304,'el usuario '+ usuario + ' tiene ya la salida internet activada');
                    ASender.SendReply;
                 end
              else
                  begin
                      //writeln('Activar Internet: Orden o número parametros incorrectos');
                  end;
        except
            //writeln('Error al activar Internet');
        end;
    end;

procedure TDataModule1.desactivarInternetCommand (ASender : TIdCommand );
    const
         ORDEN_DESACTIVAR:string='iptables -A OUTPUT -p tcp -m multiport --dport 21,23,80,143,194,443,445 -m owner --uid-owner %s -j DROP 2>/dev/null';
    var
       ip_alumno,cerrar_internet:string;
       ordenDesactivar,usuario:string;
    begin
        try
            if Asender.Params.Count=1 then
                begin
                    usuario:= trim(Asender.Params[0]);
                    ordenDesactivar:=Format(ORDEN_DESACTIVAR,[usuario]);
                    Ejecutar1(ordenDesactivar);
                    Asender.Reply.SetReply(303,'Alumno '+ usuario +' tiene la salida a internet desactivada');
                    ASender.SendReply;
                end
            else
                begin
                    //writeln('Desactivar Internet: Orden o número parametros incorrectos');
                end;
        except
            //writeln('Error al desactivar Internet');
        end;
    end;

procedure TDataModule1.hallarGatewayCommand (ASender : TIdCommand );
    begin
        try
             Asender.Reply.SetReply(305,miservidor.Gateway);
             ASender.SendReply;
        except
             //writeln('Error al hallar gateway')
        end;
    end;

procedure TDataModule1.hallarHostCommand(ASender: TIdCommand);
    begin
        try
             Asender.Reply.SetReply(307,miservidor.Host);
             ASender.SendReply;
        except

        end;
    end;

procedure TDataModule1.hallarHostMacCommand(ASender: TIdCommand);
    var
       hostmac:string;
    begin
        try
             hostmac:=miservidor.Host+'#'+miservidor.MAC;
             Asender.Reply.SetReply(308,hostmac);
             ASender.SendReply;
        except
             //writeln('Error al hallar MAC/IP');
        end;
    end;

procedure TDataModule1.hallarMACCommand (ASender : TIdCommand );
    begin
        try
             Asender.Reply.SetReply(301,miservidor.MAC);
             ASender.SendReply;
        except
             writeln('Error al hallarMAC');
        end;
    end;

procedure TDataModule1.IdCmdTCPServer1AfterCommandHandler(
  ASender: TIdCmdTCPServer; AContext: TIdContext);
    begin

    end;

procedure TDataModule1.IniciarDemonio(iport:integer;ihost:string);
    begin
        with IdCmdTCPServer1 do
            begin
                Bindings.Clear;
                Bindings.Add;
                Bindings.items[0].IP:=ihost;
                Bindings.Items[0].Port:=iport;
                DefaultPort:=iport;
                active:=true;
            end;
    end;

procedure TDataModule1.reiniciaServerAlumnoCommand(ASender: TIdCommand);
    const
         ORD_HALLAR_PID_SERVIDOR_ACTIVO:string='netstat -npa | grep -v grep | grep %s |grep serveralum | tr -s " " | cut -f7 -d" " | cut -f1 -d"/"';
         ORDEN_CIERRA_SERVER_VIEJO:string='kill -9 %s';
         ORDEN_COMPRUEBA_PID:string='ps aux | grep %s |grep serveralumnolinex | grep -v grep | tr -s " " | cut -f2 -d" "';
    var
         ip_equipo_cerrar:string;
         puerto_server_cerrar:string;
         pid_serveralumno_activo:string;
         valor_pid_comprobado:string;
         ord_cierra_viejo:string;
         ord_hallar_pid_server:String;
    begin
        try
             if Asender.Params.Count=1 then
                 begin
                    ip_equipo_cerrar:= trim(Asender.Params[0]);
                    if Length(ip_equipo_cerrar)<8 then exit;
                    puerto_server_cerrar:=ObtenerPuerto(ip_equipo_cerrar);
                    if Trim(puerto_server_cerrar)='' then exit;
                    ord_hallar_pid_server:=Format(ORD_HALLAR_PID_SERVIDOR_ACTIVO,[puerto_server_cerrar]);
                    pid_serveralumno_activo:=Trim(HallarDato1(ord_hallar_pid_server));
                    if Trim( pid_serveralumno_activo)='' then exit;
                    valor_pid_comprobado:=Format( ORDEN_COMPRUEBA_PID,[pid_serveralumno_activo]);
                    valor_pid_comprobado:=trim(HallarDato1(valor_pid_comprobado));
                    if (pid_serveralumno_activo =  valor_pid_comprobado)   then
                        begin
                            ord_cierra_viejo:=Format(ORDEN_CIERRA_SERVER_VIEJO,[pid_serveralumno_activo]);
                            Ejecutar1(ord_cierra_viejo);
                        end;
                 end
              else
                  begin
                     // writeln('Reinicia server: Orden o número parametros incorrectos');
                  end;
        except
           // writeln('Error al cerrar serveralumno');
        end;
    end;

function TDataModule1.ObtenerPuerto(ipequipo:string):String;
    const
        ORD_NOM_EQUIPO:string='echo %s | cut -f4 -d"."';
    var
         ordenip:string;
         mipuerto,miequipo1:string;
         longip:integer;
         finalport:integer;
    begin
         ordenip:=Format(ORD_NOM_EQUIPO,[ipequipo]);
         miequipo1:=Trim(HallarDato1(ordenip));
         finalport:=strtoint(miequipo1);
         mipuerto:=inttostr(37000+finalport);
         result:= mipuerto;
    end;

initialization
  {$I demonio.lrs}
   setlength(g_ips_equipos,g_num_ord_aula);
   miservidor:=Tservidor.create();
   DataModule1:=TDataModule1.create(nil);
Finalization
FreeAndNil(DataModule1);
FreeAndNil(miservidor);;

end .

