unit demonio ;

{$mode objfpc}{$H+}

interface 

uses 
  unix,clservidor,globales,Classes , SysUtils , FileUtil , LResources , Forms , Controls , Dialogs ,
  IdCmdTCPServer, IdCommandHandlers;

type 

  { TDataModule1 }

  TDataModule1 = class (TDataModule )
    IdCmdTCPServer1 : TIdCmdTCPServer ;
    procedure activarAccesoInternetCommand(ASender: TIdCommand);
    procedure apagarEquipoCommand (ASender : TIdCommand );
    procedure DataModuleCreate(Sender: TObject);
    procedure desactivarAccesoInternetCommand(ASender: TIdCommand);
    procedure hallarHostMacCommand(ASender: TIdCommand);
    procedure iniciarCanonCommand(ASender: TIdCommand);
    procedure terminarCanonCommand(ASender: TIdCommand);
    procedure videoVLCCommand(ASender: TIdCommand);
    procedure videoVLCNoCommand(ASender: TIdCommand);
  private
    procedure Ejecutar1 (comando : string );
    procedure IniciarDemonio(iport: integer; ihost: string);
    { private declarations }
  public 
    { public declarations }
  end ; 

var 
  DataModule1 : TDataModule1 ; 

implementation 

{ TDataModule1 }
procedure TDataModule1.IniciarDemonio(iport:integer;ihost:string);
    begin
        with IdCmdTCPServer1 do
            begin
                Bindings.Clear;
                Bindings.Add;
                Bindings.items[0].IP:=ihost;
                Bindings.Items[0].Port:=iport;
                DefaultPort:=iport;
                active:=true;
            end;
    end;
procedure TDataModule1.apagarEquipoCommand (ASender : TIdCommand );
    begin
        try
            miservidor.apagarEquipo;
            Asender.Reply.SetReply(302,'Apagando equipo');
            ASender.SendReply;
            if IdCmdTCPServer1.Active then IdCmdTCPServer1.Active:=false;
            Application.Terminate;
        except
           // writeln('Error al apagar equipo');
        end;
    end;

procedure TDataModule1.activarAccesoInternetCommand(ASender: TIdCommand);
    const
         ORDEN_ACTIVAR0:string='iptables-save| grep "owner %s"|head -1';
         ORDEN_ACTIVAR1:string='iptables %s 2>/dev/null';
    var
         datosorden:string;
         usuario:string;
    begin
        try
             if Asender.Params.Count=1 then
                 begin
                    usuario:= trim(Asender.Params[0]);
                    datosorden:=Format(ORDEN_ACTIVAR0,[usuario]);
                    datosorden:=miservidor.HallarDato(datosorden);
                    if datosorden ='' then exit;
                    datosorden:=StringReplace(datosorden, '-A ', '-D ',[rfReplaceAll]);
                    datosorden:= Format(ORDEN_ACTIVAR1,[datosorden]);
                    Ejecutar1(datosorden);
                    Asender.Reply.SetReply(304,'el usuario '+ usuario + ' tiene ya la salida internet activada');
                    ASender.SendReply;
                 end
              else
                  begin
                      //writeln('activar internet Orden o número parametros incorrectos');
                  end;
        except
           // writeln('Error al activar Internet');
        end;
    end;
procedure TDataModule1.desactivarAccesoInternetCommand(ASender: TIdCommand);
    const
         ORDEN_DESACTIVAR:string='iptables -A OUTPUT -p tcp -m multiport --dport 21,23,80,143,194,443,445 -m owner --uid-owner %s -j DROP 2>/dev/null';
    var
       ip_alumno,cerrar_internet:string;
       ordenDesactivar,usuario:string;
    begin
        try
            if Asender.Params.Count=1 then
                begin
                    usuario:= trim(Asender.Params[0]);
                    ordenDesactivar:=Format(ORDEN_DESACTIVAR,[usuario]);
                    Ejecutar1(ordenDesactivar);
                    Asender.Reply.SetReply(303,'Alumno '+ usuario +' tiene la salida a internet desactivada');
                    ASender.SendReply;
                end
            else
                begin
                   // writeln('desactivar internet Orden o número parametros incorrectos');
                end;
        except
            writeln('Error al desactivar Internet');
        end;
    end;

procedure TDataModule1.DataModuleCreate(Sender: TObject);
    begin
         IniciarDemonio(36999,'0.0.0.0');
    end;

procedure TDataModule1.Ejecutar1 (comando:string);
    begin;
          unix.fpSystem(comando);
    end;

procedure TDataModule1.hallarHostMacCommand(ASender: TIdCommand);
    var
       hostmac:string;
    begin
        try
             hostmac:=miservidor.Host+'#'+miservidor.MAC;
             Asender.Reply.SetReply(308,hostmac);
             ASender.SendReply;
        except
             //writeln('Error al detectar el mac');
        end;
    end;

procedure TDataModule1.iniciarCanonCommand(ASender: TIdCommand);
   const
         ORD_CIERRA_LDM:String='';
         ORD_INICIA_USUARIO:string='';
   var
        usuario,contrasena,miorden:string;
    begin
          try
          if ASender.Params.Count = 2  then
              begin
                 usuario:=ASender.Params[0];
                 contrasena:=ASender.Params[1];
                 Ejecutar1(ORD_CIERRA_LDM);
                 sleep(200);
                 miorden:=Format(ORD_INICIA_USUARIO,[usuario,contrasena]);
                 Ejecutar1(miorden);
                 end
          else
              begin
                 //writeln('Numero de parámetros incorrectos')
              end;
          except
             // writeln('Error al iniciar cañón')
          end;
    end;

procedure TDataModule1.terminarCanonCommand(ASender: TIdCommand);
    const
         ORD_TERMINAR_CANON:string='';
    begin
          try
          if ASender.Params.Count = 0  then
              begin
                 Ejecutar1(ORD_TERMINAR_CANON);
              end
          else
              begin
                // writeln('Numero de parámetros incorrectos')
              end;
          except
             // writeln('Error al cerrar cañón')
          end;
     end;

procedure TDataModule1.videoVLCCommand(ASender: TIdCommand);
    const
         ORD_ANADIR_IPVLC:String='/sbin/route add -net %s/24 gw %s &';
         ORD_VIDEO:String='su -c "DISPLAY=:7.0 vlc --video-on-top --skip-frames -f --no-audio udp:@%s" nobody &';
    var
        ipgw,ipvlc,miorden:string;
    begin
          try
          if ASender.Params.Count = 2  then
              begin
                 ipvlc:=ASender.Params[0];
                 ipgw:=ASender.Params[1];
                 miorden:=Format(ORD_ANADIR_IPVLC,[ipgw,ipvlc]);
                 Ejecutar1(miorden);
                 sleep(200);
                 miorden:=Format(ORD_VIDEO,[ipvlc]);
                 Ejecutar1(miorden);
                 end
          else
              begin
                 //writeln('videoVLC Numero de parámetros incorrectos')
              end;
          except
             // writeln('Error al iniciar vlc')
          end;
    end;

procedure TDataModule1.videoVLCNoCommand(ASender: TIdCommand);
     const
          ORD_VLC_NO:string='killall -9 vlc';
     begin
        try
            Ejecutar1(ORD_VLC_NO);
        except
            writeln('Error al iniciar vlc')
        end;
    end;

initialization
  {$I demonio.lrs}
   miservidor:=Tservidor.create();
   DataModule1:=TDataModule1.create(nil);
   miservidor.compruebaServerAlumnoActivo();
Finalization
FreeAndNil(DataModule1);
FreeAndNil(miservidor);;

end .

